"use strict";
var __getOwnPropNames = Object.getOwnPropertyNames;
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};

// package.json
var require_package = __commonJS({
  "package.json"(exports2, module2) {
    module2.exports = {
      name: "eslint-plugin-demo-typescript",
      version: "0.0.2-beta.0",
      description: "Demonstrating an eslint plugin written in TypeScript",
      main: "dist/index.js",
      files: [
        "docs/",
        "dist/"
      ],
      type: "commonjs",
      exports: {
        ".": {
          default: "./dist/index.js"
        },
        "./package.json": "./package.json"
      },
      keywords: [
        "eslint",
        "eslintplugin",
        "eslint-plugin",
        "typescript"
      ],
      homepage: "https://www.npmjs.com/package/eslint-plugin-demo-typescript",
      repository: {
        type: "git",
        url: "https://github.com/francoismassart/eslint-plugin-demo-typescript"
      },
      bugs: "https://github.com/francoismassart/eslint-plugin-demo-typescript/issues",
      scripts: {
        build: "tsc --build",
        "build:time": "tsc --build --diagnostics",
        tsup: "tsup ./src/index.ts",
        "docs:init": "eslint-doc-generator --init-rule-docs",
        "docs:update": "eslint-doc-generator",
        "test:jest": "jest",
        test: "vitest"
      },
      license: "ISC",
      dependencies: {
        "@typescript-eslint/types": "^7.13.0",
        "@typescript-eslint/utils": "^7.13.0",
        eslint: "^8.56.0"
      },
      devDependencies: {
        "@types/eslint": "^8.56.10",
        "@types/jest": "^29.5.12",
        "@typescript-eslint/parser": "^7.13.0",
        "@typescript-eslint/rule-tester": "^7.13.0",
        "eslint-doc-generator": "^1.7.1",
        jest: "^29.7.0",
        "ts-jest": "^29.1.4",
        tsup: "^8.1.0",
        typescript: "^5.4.5",
        vitest: "^1.6.0"
      }
    };
  }
});

// src/rules/my-rule.ts
var import_eslint_utils = require("@typescript-eslint/utils/eslint-utils");
var import_utils = require("@typescript-eslint/utils");
var createRule = (0, import_eslint_utils.RuleCreator)((name2) => `https://my-website.io/eslint/${name2}`);
var myRule = createRule({
  name: "my-rule",
  meta: {
    docs: {
      description: "An example ESLint rule"
    },
    hasSuggestions: true,
    messages: {
      // Message IDs don't need to be prefixed, I just find it easier to keep track of them this way
      "issue:var": "Prefer using `let` or `const`",
      "fix:let": "Replace this `var` declaration with `let`",
      "fix:const": "Replace this `var` declaration with `const`"
    },
    schema: [],
    type: "suggestion"
  },
  defaultOptions: [],
  create: (context) => {
    return {
      VariableDeclaration: (node) => {
        if (node.kind === "var") {
          const range = [
            node.range[0],
            node.range[0] + 3
            /* 'var'.length */
          ];
          context.report({
            node,
            messageId: "issue:var",
            // Prints the message with this ID when a problem is found
            suggest: [
              {
                messageId: "fix:let",
                fix: (fixer) => fixer.replaceTextRange(range, "let")
              },
              {
                messageId: "fix:const",
                fix: (fixer) => fixer.replaceTextRange(range, "const")
              }
            ]
          });
        }
      }
    };
  }
});

// src/rules/index.ts
var rules = {
  "my-rule": myRule
};

// src/index.ts
var { name, version } = require_package();
var plugin = {
  meta: {
    name,
    version
  },
  rules
};
module.exports = plugin;
